// SerialPortDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SerialPort.h"
#include "SerialPortDlg.h"

#include "SetupDlg.h"

#define WM_NEW_DATA_ARRIVE WM_USER+1

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSerialPortDlg dialog

CSerialPortDlg::CSerialPortDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSerialPortDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSerialPortDlg)
	m_strReceive = _T("");
	m_strTransmit = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSerialPortDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSerialPortDlg)
	DDX_Control(pDX, IDC_RECEIVE, m_CtrlReceive);
	DDX_Text(pDX, IDC_RECEIVE, m_strReceive);
	DDX_Text(pDX, IDC_TRANSMIT, m_strTransmit);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSerialPortDlg, CDialog)
	//{{AFX_MSG_MAP(CSerialPortDlg)
	ON_BN_CLICKED(IDC_SETUP, OnSetup)
	ON_BN_CLICKED(IDC_OPEN, OnOpen)
	ON_BN_CLICKED(IDC_CLEAR_RECE, OnClearRece)
	ON_BN_CLICKED(IDC_CLEAR_SEND, OnClearSend)
	ON_BN_CLICKED(IDC_RECE, OnRece)
	ON_BN_CLICKED(IDC_SEND, OnSend)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_CHECK_HEX, OnCheckHex)
	ON_BN_CLICKED(IDC_SEND_FILE, OnSendFile)
	ON_BN_CLICKED(IDC_SAVE_RECEIVED, OnSaveReceived)
	ON_BN_CLICKED(IDC_CHECK_HEX_SEND, OnCheckHexSend)
	ON_MESSAGE(WM_NEW_DATA_ARRIVE,OnDataArrivedMsg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSerialPortDlg message handlers

BOOL CSerialPortDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	//ʼ
	BaudRates[0]=1200;
	BaudRates[1]=2400;
	BaudRates[2]=4800;
	BaudRates[3]=9600;
	BaudRates[4]=19200;
	BaudRates[5]=38400;
	BaudRates[6]=57600;
	BaudRates[7]=115200;

	PortIDs[0]="COM1:";
	PortIDs[1]="COM2:";
	PortIDs[2]="COM3:";
	PortIDs[3]="COM4:";
	PortIDs[4]="COM5:";
	PortIDs[5]="COM6:";
	PortIDs[6]="COM7:";
	PortIDs[7]="COM8:";
	PortIDs[8]="COM9:";

	PortNo=1;
	BaudRate=3;
	DataBits=8;
	StopBits=ONESTOPBIT;
	Parity=NOPARITY;

	Open=FALSE;
	Receive=FALSE;
	HexDisplay=FALSE;
	HexSend=FALSE;

	m_strDataReceived=_T("");

	m_pSerial=new CPSerialPort();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSerialPortDlg::OnDataArrive(char *data,int length,DWORD userdata)
{
	CSerialPortDlg *pWnd=(CSerialPortDlg *)userdata;
	::SendMessage(pWnd->m_hWnd,WM_NEW_DATA_ARRIVE,(WPARAM)data,LPARAM(length));
}

void CSerialPortDlg::OnDataArrivedMsg(WPARAM wParam,LPARAM lParam)
{
	//յ
	int length=(int)lParam;
	char *data=(char*)wParam;
	CString THex(_T(""));

	int i;

	if(length!=0)
	{
		if(HexDisplay)
		{
			for(i=0;i<length;i++)
			{
				if(data[i]<16)
				{
					THex.Format(_T("0%X "),data[i]);
				}
				else
				{
					THex.Format(_T("%2X "),data[i]);
				}
				m_strDataReceived+=THex;
			}
		}
		else
		{
			m_strDataReceived=CString(data).Left(length);
		}
		m_strReceive+=m_strDataReceived;
		m_strDataReceived=_T("");
		SetDlgItemText(IDC_RECEIVE,m_strReceive);
		m_CtrlReceive.SetSel(m_strReceive.GetLength(),m_strReceive.GetLength(),FALSE);
	}
}


BOOL CSerialPortDlg::SaveReceivedToFile(LPCTSTR FileName)
{
	int i;
	CFile cf;
	DWORD dwBytesToSave=m_strReceive.GetLength();
	
	if(!cf.Open(FileName,CFile::modeWrite|CFile::modeCreate))
	{
		AfxMessageBox(_T("޷Textļ"));
	}

	cf.Seek(0,CFile::begin);
	char * buf=new char[dwBytesToSave];
	for(i=0;i<dwBytesToSave;i++)
	{
		buf[i]=m_strReceive.GetAt(i);
	}	

	cf.Write(buf,dwBytesToSave);
	
	delete[] buf;
	cf.Close();

	return TRUE;
}

void CSerialPortDlg::OnSetup() 
{
	CSetupDlg* Dialog1;
	Dialog1=new CSetupDlg;

	Dialog1->BaudRate=BaudRate;
	Dialog1->PortNo=PortNo-1;
	Dialog1->DataBits=DataBits-7;
	Dialog1->StopBits=StopBits;
	Dialog1->Parity=Parity;

	if(Dialog1->DoModal()==IDOK)
	{
		BaudRate=Dialog1->BaudRate;
		PortNo=Dialog1->PortNo+1;
		DataBits=Dialog1->DataBits+7;
		StopBits=Dialog1->StopBits;
		Parity=Dialog1->Parity;
	}

	delete Dialog1;
}

void CSerialPortDlg::OnOpen() 
{
	if(!Open)
	{
		PortID=PortIDs[PortNo-1];
		Open=m_pSerial->OpenPort(PortID,BaudRates[BaudRate],DataBits,StopBits,Parity,OnDataArrive,(DWORD)this);
		if(Open)
		{
			SetDlgItemText(IDC_OPEN,_T("رն˿"));
		}
	}
	else
	{
		m_pSerial->ClosePort();
		Open=FALSE;
		Receive=FALSE;
		SetDlgItemText(IDC_RECE,_T(""));
		SetDlgItemText(IDC_OPEN,_T("򿪶˿"));
	}
}

void CSerialPortDlg::OnClearRece() 
{
	m_strReceive=_T("");
	GetDlgItemText(IDC_TRANSMIT,m_strTransmit);
	UpdateData(FALSE);
}

void CSerialPortDlg::OnClearSend() 
{
	m_strTransmit=_T("");
	UpdateData(FALSE);
}

void CSerialPortDlg::OnRece() 
{
	if(!Receive)
	{
		Receive=m_pSerial->Activate();
		if(Receive)
		{
			SetDlgItemText(IDC_RECE,_T(""));
		}
	}
	else
	{
		m_pSerial->Deactivate();
		Receive=FALSE;
		SetDlgItemText(IDC_RECE,_T(""));
	}
}

void CSerialPortDlg::OnSend() 
{
	DWORD dwCharToWrite=0;
	DWORD dwBytesWritten=0;
	int i,j;

	GetDlgItemText(IDC_TRANSMIT,m_strTransmit);
	if(!HexSend)
	{
		dwCharToWrite=(DWORD)m_strTransmit.GetLength();
	}
	else
	{
		for(i=0;i<m_strTransmit.GetLength()/2;i++)
		{
			if(((m_strTransmit.GetAt(i*2)>='0'&&m_strTransmit.GetAt(i*2)<='9')||(m_strTransmit.GetAt(i*2)>='A'&&m_strTransmit.GetAt(i*2)<='F'))&&((m_strTransmit.GetAt(i*2+1)>='0'&&m_strTransmit.GetAt(i*2+1)<='9')||(m_strTransmit.GetAt(i*2+1)>='A'&&m_strTransmit.GetAt(i*2+1)<='F')))
			{
				dwCharToWrite++;
			}
		}
	}
	dwBytesWritten=0;
	
	if(Open&&dwCharToWrite!=0)
	{
		char* buf=new char[dwCharToWrite];
		if(!HexSend)
		{			
			
			for(i=0;i<(int)dwCharToWrite;i++)
			{
				buf[i]=(char)m_strTransmit.GetAt(i);
			}
	
		}
		else
		{
			j=0;
			for(i=0;i<m_strTransmit.GetLength()/2;i++)
			{
				if(((m_strTransmit.GetAt(i*2)>='0'&&m_strTransmit.GetAt(i*2)<='9')||(m_strTransmit.GetAt(i*2)>='A'&&m_strTransmit.GetAt(i*2)<='F'))&&((m_strTransmit.GetAt(i*2+1)>='0'&&m_strTransmit.GetAt(i*2+1)<='9')||(m_strTransmit.GetAt(i*2+1)>='A'&&m_strTransmit.GetAt(i*2+1)<='F')))
				{
					if(m_strTransmit.GetAt(i*2+1)>='0'&&m_strTransmit.GetAt(i*2+1)<='9')
					{
						buf[j]=m_strTransmit.GetAt(i*2+1)-48;
					}
					else
					{
						buf[j]=m_strTransmit.GetAt(i*2+1)-55;
					}
					if(m_strTransmit.GetAt(i*2)>='0'&&m_strTransmit.GetAt(i*2)<='9')
					{
						buf[j]+=(m_strTransmit.GetAt(i*2)-48)*16;
					}
					else
					{
						buf[j]+=(m_strTransmit.GetAt(i*2)-55)*16;
					}
					j++;
				}
			}
		}
		dwBytesWritten=m_pSerial->WritePort(buf,dwCharToWrite);
		if(dwBytesWritten==0)
		{
			AfxMessageBox(_T("޷˿дݣ"));
		}
		delete[] buf;		
	}
}

void CSerialPortDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	m_pSerial->ClosePort();
}

void CSerialPortDlg::OnCheckHex() 
{
	HexDisplay=!HexDisplay;
}

void CSerialPortDlg::OnSendFile() 
{
	if(!Open)
	{
		AfxMessageBox(_T("ȴ򿪴!"));
		return;
	}
	CString FileName(_T(""));
	CFileDialog FileDlg(TRUE,NULL,NULL,OFN_HIDEREADONLY,_T("All Files(*.*)|*.*||"));
	if(FileDlg.DoModal()==IDOK)
	{
		FileName=FileDlg.GetPathName();
	}
	if(FileName!=_T(""))
	{
		m_pSerial->WriteFileToPort(FileName);
	}
}

void CSerialPortDlg::OnSaveReceived() 
{
	CString FileName(_T(""));
	CFileDialog FileDlg(FALSE,NULL,NULL,OFN_HIDEREADONLY,TEXT("Text Files(*.txt)|*.txt||"));
	if(FileDlg.DoModal()==IDOK)
	{
		FileName=FileDlg.GetPathName();
	}
	if(FileName!=_T(""))
	{
		SaveReceivedToFile(FileName);
	}
}

void CSerialPortDlg::OnCheckHexSend() 
{
	HexSend=!HexSend;
}
